#include <stdio.h>
#include <math.h>
#include <asm/msr.h>

int main(int argc, char **argv)
{
    unsigned long t1, t2, tsccost;
    double f;

    rdtscl(t1); /* read time stamp counter    */
    rdtscl(t2); /* as a "long" (32 bit) value */
    tsccost = t2 - t1;

    rdtscl(t1); /* time stamp counter, 32 bits */
    f = sin(1.0);
    rdtscl(t2);
    printf("sin(1) takes %5li cycles\n", t2 - t1 - tsccost);

    rdtscl(t1); /* time stamp counter, 32 bits */
    f = tan(1.0);
    rdtscl(t2);
    printf("tan(1) takes %5li cycles\n", t2 - t1 - tsccost);

    rdtscl(t1); /* time stamp counter, 32 bits */
    f = sin(0.0);
    rdtscl(t2);
    printf("sin(0) takes %5li cycles\n", t2 - t1 - tsccost);

    printf("%p %p", sin, tan);
    return 0;
}
/* per compilare: "make trig LDFLAGS=-lm" */
